#ifndef CLIENT_DE_RAPPEL_H
#define CLIENT_DE_RAPPEL_H

#include <windows.h>
#include "../Commun/IConfigTemps.h"

class ClientDeRappel : public virtual ITempsQuiPasse
{
   int m_CptRef;
public:
   unsigned long __stdcall AddRef () {return ++m_CptRef; }
   unsigned long __stdcall Release () { if (--m_CptRef != 0) return m_CptRef; delete this; return 0; }
   HRESULT __stdcall QueryInterface (REFIID riid, void **ppv)
   {
      if (riid == IID_IUnknown)
      {
         *ppv = static_cast<IUnknown *> (static_cast<ITempsQuiPasse *> (this));
      }
      else if (riid == IID_ITempsQuiPasse)
      {
         *ppv = static_cast<ITempsQuiPasse *> (this);
      }
      else
      {
         *ppv = 0;
         return E_NOINTERFACE;
      }
      AddRef ();
      return S_OK;
   }

   HRESULT __stdcall Tick (int UniteDeTemps, int Saison);
   ClientDeRappel () : m_CptRef (1) {}
   virtual ~ClientDeRappel () {}
};

#endif // !defined CLIENT_DE_RAPPEL_H
