#ifndef COMPOSANTSERVEURTEMPSQUIPASSE_H
#define COMPOSANTSERVEURTEMPSQUIPASSE_H

#include "../Commun/IConfigTemps.h"
#include "IConfigTempsImpl.h"
#include "IConnectionPointContainerImpl.h"
#include "../../StdOutilsCOM_Lib/IUnknownImpl.h"
#include "../../ThreadManager/Minuterie.h"

// ----------------------------------------------------
// ----------------------------------------------------
// Class ComposantServeurTempsQuiPasse:
//    implmentation encapsule de IConfigTemps et
//    de IConnectionPoint
// ----------------------------------------------------

class ComposantServeurTempsQuiPasse : virtual public IConfigTempsImpl,
                                      virtual public IUnknownImpl,
                                      virtual public IConnectionPointContainerImpl,
                                      virtual public Minuterie
{
public:
   // Pour IUnknown
   unsigned long __stdcall AddRef () { return IUnknownImpl::AddRef (); }
   unsigned long __stdcall Release () { return IUnknownImpl::Release (); }
   HRESULT __stdcall QueryInterface (REFIID riid, void **ppv);

   // constructeur
   ComposantServeurTempsQuiPasse ();
   // destructeur
   ~ComposantServeurTempsQuiPasse ();

   // Gestion interne
   void Tic ();
};

#endif // !defined COMPOSANTSERVEURTEMPSQUIPASSE_H
