#include "EnumerateurDeConnexions.h"
#include <vector>

CONNECTDATA *EnumerateurDeConnexions::GenererLLRep () const
{
   if (m_PointsDeConnexion.empty ())
      return 0;
   CONNECTDATA *pLLRep = new CONNECTDATA [m_PointsDeConnexion.size ()];
   std::vector<Connexion *>::const_iterator itt;
   int i;
   for (i= 0, itt = m_PointsDeConnexion.begin ();
        i < m_PointsDeConnexion.size () && itt != m_PointsDeConnexion.end ();
        itt++, i++)
   {
      CONNECTDATA Temp = { (*itt)->GetInterface (), (*itt)->GetCookie () };
      pLLRep[i] = Temp;
   }
   return pLLRep;
}
