#ifndef ICONNECTIONPOINTCONTAINERIMPL_H
#define ICONNECTIONPOINTCONTAINERIMPL_H

#include <vector>
#include <olectl.h> // pour les points de connexion
#include "../../StdOutilsCOM_Lib/IUnknownImpl.h"

class PointDeConnexion;

class IConnectionPointContainerImpl : virtual public IConnectionPointContainer
{
   std::vector<PointDeConnexion *> m_PointsDeConnexion;
public:
   // Pour IConnectionPointContainer
   HRESULT STDMETHODCALLTYPE EnumConnectionPoints(IEnumConnectionPoints **ppEnum);
   HRESULT STDMETHODCALLTYPE FindConnectionPoint(REFIID riid,
                                                 IConnectionPoint **ppCP);

   // Oprations internes
   bool Ajouter (PointDeConnexion *);
   
   // Pour gestion normale
   IConnectionPointContainerImpl ();
   virtual ~IConnectionPointContainerImpl ();
};

#endif // !defined ICONNECTIONPOINTCONTAINERIMPL_H
