#include "PointDeConnexion.h"

HRESULT PointDeConnexion::QueryInterface (REFIID riid, void **ppv)
{
   if (riid == IID_IUnknown)
   {
      *ppv = static_cast<IUnknown *>(static_cast<IConnectionPointImpl *>(this));
   }
   else if (riid == IID_IConnectionPoint)
   {
      *ppv = static_cast<IConnectionPoint *>(this);
   }
   else
   {
      // traitement d'erreur
      *ppv = 0; // NULL
      return E_NOINTERFACE;
   }
   AddRef ();
   return S_OK;
}

